aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorShahab Vahedi <list+sbo@vahedi.org>2024-06-12 23:54:16 +0700
committerWilly Sudiarto Raharjo <willysr@slackbuilds.org>2024-06-15 07:37:47 +0700
commit17fb7a7a9cce658736fd8796cc6b305d25967e92 (patch)
tree9585e7037ec1f17fcf79b05ced37b23970ff0833
parentbb2182f4dc16116d8c7a8b68c591dc2be09300bc (diff)
development/creduce: Added (C and C++ program reducer).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
-rw-r--r--development/creduce/README10
-rw-r--r--development/creduce/creduce.SlackBuild103
-rw-r--r--development/creduce/creduce.info10
-rw-r--r--development/creduce/slack-desc19
4 files changed, 142 insertions, 0 deletions
diff --git a/development/creduce/README b/development/creduce/README
new file mode 100644
index 0000000000000..b52b2398e97c2
--- /dev/null
+++ b/development/creduce/README
@@ -0,0 +1,10 @@
+C-Reduce is a tool that takes a large C or C++ program that has a
+property of interest (such as triggering a compiler bug) and
+automatically produces a much smaller C/C++ program that has the same
+property. It is intended for use by people who discover and report bugs
+in compilers and other tools that process C/C++ code.
+
+A sample run would look like:
+
+$ creduce --n $(nproc) --timing build_and_verify.sh test.i
+$ creduce --help
diff --git a/development/creduce/creduce.SlackBuild b/development/creduce/creduce.SlackBuild
new file mode 100644
index 0000000000000..a00819e04fd68
--- /dev/null
+++ b/development/creduce/creduce.SlackBuild
@@ -0,0 +1,103 @@
+#!/bin/bash
+
+# Slackware build script for creduce
+
+# Copyright 2024 Shahab Vahedi, NL
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=creduce
+VERSION=${VERSION:-2.11.0.4ae77d1}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+# Currently, 4ae77d1 is the top of llvm-13.0 branch
+# See https://github.com/csmith-project/creduce/issues/239
+COMMIT_HASH=4ae77d1
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+elif [ "$ARCH" = "aarch64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+else
+ SLKCFLAGS="-O2"
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$COMMIT_HASH*
+tar xvf $CWD/$PRGNAM-$COMMIT_HASH*.tar.gz
+cd $PRGNAM-$COMMIT_HASH*/
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+./configure --prefix=/usr
+
+make
+make install-strip DESTDIR=$PKG
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION/delta
+cp -a \
+ delta/License.txt \
+ delta/Readme \
+ delta/www \
+ $PKG/usr/doc/$PRGNAM-$VERSION/delta
+cp -a \
+ README.md \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/development/creduce/creduce.info b/development/creduce/creduce.info
new file mode 100644
index 0000000000000..f52ae7fa72382
--- /dev/null
+++ b/development/creduce/creduce.info
@@ -0,0 +1,10 @@
+PRGNAM="creduce"
+VERSION="2.11.0.4ae77d1"
+HOMEPAGE="https://github.com/csmith-project/creduce"
+DOWNLOAD="https://github.com/csmith-project/creduce/archive/4ae77d1/creduce-4ae77d1.tar.gz"
+MD5SUM="1d33c533286990731c2d154c7ff81424"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="perl-Exporter-Lite perl-File-Which perl-Getopt-Tabular perl-Regexp-Common"
+MAINTAINER="Shahab Vahedi"
+EMAIL="list+sbo@vahedi.org"
diff --git a/development/creduce/slack-desc b/development/creduce/slack-desc
new file mode 100644
index 0000000000000..114ec94e1063e
--- /dev/null
+++ b/development/creduce/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+creduce: creduce (a C and C++ program reducer)
+creduce:
+creduce: C-Reduce is a tool that takes a large C or C++ program that has a
+creduce: property of interest (such as triggering a compiler bug) and
+creduce: automatically produces a much smaller C/C++ program that has the same
+creduce: property.
+creduce:
+creduce:
+creduce:
+creduce:
+creduce: